﻿using System;
using System.Reflection.Emit;

namespace TestProject
{
    /// <summary>
    /// 참조 헬퍼
    /// </summary>
    public static class ReferenceHelper
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Field
        ////////////////////////////////////////////////////////////////////////////////////////// Static
        //////////////////////////////////////////////////////////////////////////////// Public

        #region Field

        /// <summary>
        /// 고정 포인터 구하기 액션
        /// </summary>
        public static readonly Action<object, Action<IntPtr>> GetPinnedPointer;

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Static

        #region 생성자 - ReferenceHelper()

        /// <summary>
        /// 생성자
        /// </summary>
        static ReferenceHelper()
        {
            DynamicMethod dynamicMethod = new DynamicMethod
            (
                "GetPinnedPointer",
                typeof(void),
                new[] { typeof(object), typeof(Action<IntPtr>) },
                typeof(ReferenceHelper).Module
            );

            ILGenerator ilGenerator = dynamicMethod.GetILGenerator();

            ilGenerator.DeclareLocal(typeof(object), true);

            ilGenerator.Emit(OpCodes.Ldarg_0);
            ilGenerator.Emit(OpCodes.Stloc_0);
            ilGenerator.Emit(OpCodes.Ldarg_1);
            ilGenerator.Emit(OpCodes.Ldloc_0);
            ilGenerator.Emit(OpCodes.Conv_I );
            ilGenerator.Emit(OpCodes.Call, typeof(Action<IntPtr>).GetMethod("Invoke"));
            ilGenerator.Emit(OpCodes.Ret    );

            GetPinnedPointer = (Action<object, Action<IntPtr>>)dynamicMethod.CreateDelegate(typeof(Action<object, Action<IntPtr>>));
        }

        #endregion
    }
}